// Auto-generated. Do not edit!

// (in-package grizzly_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class Ambience {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.body_lights = null;
      this.beacon = null;
      this.beep = null;
    }
    else {
      if (initObj.hasOwnProperty('body_lights')) {
        this.body_lights = initObj.body_lights
      }
      else {
        this.body_lights = new Array(4).fill(0);
      }
      if (initObj.hasOwnProperty('beacon')) {
        this.beacon = initObj.beacon
      }
      else {
        this.beacon = 0;
      }
      if (initObj.hasOwnProperty('beep')) {
        this.beep = initObj.beep
      }
      else {
        this.beep = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Ambience
    // Check that the constant length array field [body_lights] has the right length
    if (obj.body_lights.length !== 4) {
      throw new Error('Unable to serialize array field body_lights - length must be 4')
    }
    // Serialize message field [body_lights]
    bufferOffset = _arraySerializer.uint8(obj.body_lights, buffer, bufferOffset, 4);
    // Serialize message field [beacon]
    bufferOffset = _serializer.uint8(obj.beacon, buffer, bufferOffset);
    // Serialize message field [beep]
    bufferOffset = _serializer.uint8(obj.beep, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Ambience
    let len;
    let data = new Ambience(null);
    // Deserialize message field [body_lights]
    data.body_lights = _arrayDeserializer.uint8(buffer, bufferOffset, 4)
    // Deserialize message field [beacon]
    data.beacon = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [beep]
    data.beep = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 6;
  }

  static datatype() {
    // Returns string type for a message object
    return 'grizzly_msgs/Ambience';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '8271ef649dd1720612cc15f8990fdf6f';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Represents a command for the four corner body lights, indicators on the rear
    # and beeper/beacon combination on the arch.
    uint8 LIGHTS_FRONT_LEFT=0   # Only white
    uint8 LIGHTS_FRONT_RIGHT=1  # Only white
    uint8 LIGHTS_REAR_LEFT=2    # Only red
    uint8 LIGHTS_REAR_RIGHT=3   # Only red
    
    uint8[4] body_lights    # Body lights on the Grizzly
    uint8 beacon            # Overhead beacon light
    uint8 beep              # Noisemaker sound
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Ambience(null);
    if (msg.body_lights !== undefined) {
      resolved.body_lights = msg.body_lights;
    }
    else {
      resolved.body_lights = new Array(4).fill(0)
    }

    if (msg.beacon !== undefined) {
      resolved.beacon = msg.beacon;
    }
    else {
      resolved.beacon = 0
    }

    if (msg.beep !== undefined) {
      resolved.beep = msg.beep;
    }
    else {
      resolved.beep = 0
    }

    return resolved;
    }
};

// Constants for message
Ambience.Constants = {
  LIGHTS_FRONT_LEFT: 0,
  LIGHTS_FRONT_RIGHT: 1,
  LIGHTS_REAR_LEFT: 2,
  LIGHTS_REAR_RIGHT: 3,
}

module.exports = Ambience;
