// Auto-generated. Do not edit!

// (in-package grizzly_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class Indicators {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.position_light = null;
      this.autopilot_light = null;
      this.battery_light = null;
    }
    else {
      if (initObj.hasOwnProperty('position_light')) {
        this.position_light = initObj.position_light
      }
      else {
        this.position_light = 0;
      }
      if (initObj.hasOwnProperty('autopilot_light')) {
        this.autopilot_light = initObj.autopilot_light
      }
      else {
        this.autopilot_light = 0;
      }
      if (initObj.hasOwnProperty('battery_light')) {
        this.battery_light = initObj.battery_light
      }
      else {
        this.battery_light = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Indicators
    // Serialize message field [position_light]
    bufferOffset = _serializer.uint8(obj.position_light, buffer, bufferOffset);
    // Serialize message field [autopilot_light]
    bufferOffset = _serializer.uint8(obj.autopilot_light, buffer, bufferOffset);
    // Serialize message field [battery_light]
    bufferOffset = _serializer.uint8(obj.battery_light, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Indicators
    let len;
    let data = new Indicators(null);
    // Deserialize message field [position_light]
    data.position_light = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [autopilot_light]
    data.autopilot_light = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [battery_light]
    data.battery_light = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 3;
  }

  static datatype() {
    // Returns string type for a message object
    return 'grizzly_msgs/Indicators';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '96722a571f0c36ed6a0c5468800be83f';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Represents a command for the indicators on the rear panel.
    
    uint8 INDICATOR_ON      = 255
    uint8 INDICATOR_FLASH   = 15
    uint8 INDICATOR_OFF     = 0
    
    uint8 position_light    # Signal the status of the GPS system
    uint8 autopilot_light   # Signal if the system is under automatic or manual control
    uint8 battery_light     # Signal the level of the battery, 0 is empty and 255 is full.
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Indicators(null);
    if (msg.position_light !== undefined) {
      resolved.position_light = msg.position_light;
    }
    else {
      resolved.position_light = 0
    }

    if (msg.autopilot_light !== undefined) {
      resolved.autopilot_light = msg.autopilot_light;
    }
    else {
      resolved.autopilot_light = 0
    }

    if (msg.battery_light !== undefined) {
      resolved.battery_light = msg.battery_light;
    }
    else {
      resolved.battery_light = 0
    }

    return resolved;
    }
};

// Constants for message
Indicators.Constants = {
  INDICATOR_ON: 255,
  INDICATOR_FLASH: 15,
  INDICATOR_OFF: 0,
}

module.exports = Indicators;
